/* meme machine - domain modelling using recursive information
 *  storage.
 * NOTE - the code in this particular file is extremely dense. Grok everything
 * else before comming here. Ignore this file completely if you only want
 * a basic idea of the way the program in general works, this file has the
 * exotic stuff only.
 *
 * Routines defined here:
 *
 * find_multi_meta_match()
 * get_multi_meta()
 * build_from_wm()
 * tweak_compare()
 * analyse_tweak_match()
 * find_exact_match()
 * find_tweak_match()
 * tweak_build_next()
 * tweak_build()
 */

#include <stdio.h>
#include <string.h>
#include "datastru.h"

/**************************************************************************
 * find_multi_meta_match()
 * recursive - try to find a suitable metanode of 'node' that best matches
 * the current input, from posn onwards.
 * This is basically a non-tweak find_match()
 */
 
int find_multi_meta_match(net_type *net, int node,
			  nodelist_type *input, int posn, int meta_rhs)
{
  int metanode,rhs;
  int result_posn;
  int bot,mid,top, safe_mid, explore;
  int meta_posn;
  int loop;
  int found;  /*whether we got a hit*/
  
  if (net->trace>=6)
  {
    printf("** find_multi_meta_match('"); print_node(net,node);
    printf("' , '");
    for (loop=0; loop<5; loop++) print_node(net,input->data[posn+loop]);
    printf("'), meta_rhs='"); print_node(net,meta_rhs); printf("'\n");
    printf("posn=%i, input->size=%i\n",posn,input->size);
  }
  /* sanity check....*/
  if (posn>=input->size) return(FALSE);
  
  /* firstly, get the outputs of our LHS node*/
  
  bot=net->data[node+LHS_OP];
  top=bot+net->data[node+NUM_LHS_OP]-1;
  mid=0; result_posn=FALSE; found=FALSE;
  
  explore=TRUE;
  while(bot<=top && explore)
  {
    
    mid=bot+(top-bot)/2;
    metanode=net->data[mid];
    if (net->trace>=4) { printf("@ metamatch - looking at metanode '");
			     print_node(net,metanode); printf("'\n"); }
    rhs=net->data[metanode+RHS_IP];
     
    result_posn=compare(net, rhs, input, posn); /*try to find a match*/     
    if (result_posn!=FALSE) /* we got a match*/
    {
      found=TRUE;
      /* firstly, make sure we have'nt run off the end of input again... */
      if (result_posn>=input->size) return(FALSE);
      meta_posn=compare(net,meta_rhs,input,result_posn);
      if (meta_posn!=0) 
      {
	net->wmsize++; net->wm[net->wmsize]=metanode;
	net->metabest=net->wm[1];
	return(result_posn);
      }
      /*lastly, explore higher levels.. */
      meta_posn=find_multi_meta_match(net,metanode,
	                        input,result_posn,meta_rhs);	
      if (meta_posn!=0) return(meta_posn); /* if success, exit*/
      /* Next, we need to explore above and below the hit for alternatives...*/
      safe_mid=mid; explore=TRUE; if (mid==bot) explore=FALSE;
      /* first, explore down... */
      if (mid==bot) explore=FALSE;
      while (explore)
      {
        mid--;
        metanode=net->data[mid];
        if (net->trace>=4) { printf("@ metamatch - looking at metanode '");
			     print_node(net,metanode); printf("'\n"); }
	rhs=net->data[metanode+RHS_IP];     
        result_posn=compare(net, rhs, input, posn); /*try to find a match*/	
	/* firstly, make sure we have'nt run off the end of input again... */
        if (result_posn>=input->size) return(FALSE);
	
        if (result_posn!=FALSE)
        {
          /* printf("FOUND ANOTHER MATCH!!!\n"); */
	  meta_posn=compare(net,meta_rhs,input,result_posn);
	  if (meta_posn!=0) 
          {
	    net->wmsize++; net->wm[net->wmsize]=metanode;
	    net->metabest=net->wm[1];
	    return(result_posn);
          }
          /*lastly, explore higher levels.. */
          meta_posn=find_multi_meta_match(net,metanode,
	                        input,result_posn,meta_rhs);	
          if (meta_posn!=0) return(meta_posn); /* if success, exit*/
        }
        else explore=FALSE;
        if (mid<=bot) explore=FALSE;
      }
      /* now, explore up... */
      mid=safe_mid;
      explore=TRUE;
      if (mid==top) explore=FALSE;
      while (explore)
      {
        mid++;
        metanode=net->data[mid];
	if (net->trace>=4) { printf("@ metamatch: looking at metanode '");
			     print_node(net,metanode); printf("'\n"); }
        rhs=net->data[metanode+RHS_IP];    
        result_posn=compare(net, rhs, input, posn); /*try to find a match*/
	/* firstly, make sure we have'nt run off the end of input again... */
        if (result_posn>=input->size) return(FALSE); 
        if (result_posn!=FALSE)
        {
          /* printf("FOUND ANOTHER UP MATCH!!!\n"); */
	  meta_posn=compare(net,meta_rhs,input,result_posn);
	  if (meta_posn!=0) 
          {
	    net->wmsize++; net->wm[net->wmsize]=metanode;
	    net->metabest=net->wm[1];
	    return(result_posn);
          }
          /*lastly, explore higher levels.. */
          meta_posn=find_multi_meta_match(net,metanode,
	                        input,result_posn,meta_rhs);
          if (meta_posn!=0) return(meta_posn); /* if success, exit*/
        }
        else explore=FALSE;
        if (mid>=top) explore=FALSE;
      }
      /* OK, explored up and down to no avail, exit. */
      /* printf("here7\n"); return(FALSE); */
    }
    else if (net->result<0) bot=mid+1;
    else if (net->result>0) top=mid-1;
  }
  /* lastly, if we dont get a match and drop to here, try again... */
  if (!found) /*i.e. we're at the highest level of exploration... */
  {
     if (net->wmsize==MAX_WMSIZE) return(FALSE);
     else
     {
       net->wmsize++; net->wm[net->wmsize]=node;
       /* should there be a "RETURN" here? -kees */
       return get_meta(net,input,posn,meta_rhs);
     }
  }
  else return(FALSE);
}


/***************************************************************************
 *  get_meta() - wrapper for find_multi_meta_match
 */

int get_meta(net_type *net, nodelist_type *input, int posn, int meta_rhs)
{
   int result;
   int tracer;

   if (net->trace>=5) 
   {
     printf("@@@@@ get_meta - rhs='"); print_node(net,meta_rhs); 
     printf("' , data='");
     for (tracer=0; tracer<5; tracer++) printf("%c",input->data[posn+tracer]/8);
     printf("', posn=%i\n",posn);
   }
   /* Change into get_meta mode... */
   /* firstly, see if we can get a single-character tweak */
   result=compare(net,meta_rhs,input,posn+1);
   if (result !=0) /* single character tweak*/
   {
      /* printf("SINGLE CHAR TWEAK WORKS!\n"); */
      net->wmsize++; net->wm[net->wmsize]=input->data[posn];
      net->metabest=net->wm[1];
      return(posn+1);
   }
      
   /* now recurse with find_meta_match() */
   if (net->trace>=5) printf("GET_META RECURSE...\n");
   result=find_multi_meta_match(net,input->data[posn],input,posn+1,meta_rhs);
   return(result);
}

/**************************************************************************
 * build_from_wm(net)
 * freaky little recursive routine to build a binary-tree of nodes from a
 * string of nodes. Return value is node created.
 */ 

int build_from_wm(net_type *net)
{
  
  int loop;
  
  if (net->wmsize==1) return(net->wm[1]);
  else if (net->wmsize==2)
  {
     return(make_node(net,net->wm[1],net->wm[2]));
  }
  else
  {
    for (loop=1; loop<net->wmsize; loop+=2)
      net->wm[loop/2+1]=make_node(net,net->wm[loop],net->wm[loop+1]);
    if (net->wmsize%2==1) net->wm[net->wmsize/2+1]=net->wm[net->wmsize];
    net->wmsize=net->wmsize-(net->wmsize/2);
    return(build_from_wm(net));
  }
}

/****************************************************************************
 * tweak_compare() - this recursive routine compares 'node' with 
 * input->data[posn].
 * If 'node' is not a base node, compare() recurses.
 * returns updated 'posn' if exact match found, otherwise returns 0/FALSE.
 * will return '2' if a skip is allowed on the next tweak
 * it no prior tweak is set, we will try one.
 * Now including support for a single tweak.
 */
 
 
int tweak_compare(net_type *net, int node, nodelist_type *input, int posn,
		  int parent_rhs)
{

  int lhs,rhs;  /*lhs and rhs of 'node' if 'node' is not a base-node*/
  int result_lhs, result_rhs;  /*resultant positions from lhs/rhs search*/
  int tracer;
 
   if (net->trace>=5) 
   { 
     printf("**** tweak_compare('"); print_node(net,node); printf("', data='");
    for (tracer=0; tracer<5; tracer++) printf("%c",input->data[posn+tracer]/8);
    printf("'\n");
   }

  /*@@@@@@@@@@ special case - base node @@@@@@@@@*/
  
  if (node<=BASE_NODE_SPACE)
  {
     /* 3 easy scenarios, off the end, exact base-base match or failure. */
     /* Note -  parent guaranteed to be 0, because call is from tweak_match */
     if (posn>=input->size) return(0);
     else if (input->data[posn]==node)
         return(posn+1);
     else /*forget it!!!*/
     {
       net->tweaked=0;
       return(0);
     }
  } 
  
  lhs=net->data[node+LHS_IP]; 
  rhs=net->data[node+RHS_IP]; 
  
  /*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/  
  /* firstly, try to match the LHS... 2 sub-scenarios, lhs=base-node or not */
  /* printf("tweak LHS='"); print_node(net,lhs); printf("', with '");
     for (tracer=0; tracer<5; tracer++)
        print_node(net,input->data[posn+tracer]); printf("'\n"); */
 
  if (lhs<=BASE_NODE_SPACE)  /* look at lhs=base-node scenario */
  {
    if (posn>input->size)   /*corner case, run out of input*/
    {
       if (net->tweaked==2) net->tweaked=0;
       result_lhs=off_the_end(net,lhs,input,posn);
       if (result_lhs==0) {return(0); }
    }
    else if (lhs==input->data[posn])  /*exact match...*/
    {
      result_lhs=posn+1;
    }
    else /*LHS becomes a tweak, so scan forward for RHS... */
    {
      if (net->tweaked==1) /* oops, already tweaked, give it up.*/
      {
        net->tweaked=0;
        return(0);
      }

      net->wmsize=0; result_lhs=get_meta(net,input,posn,rhs);
      if (result_lhs==0) return(0); /* give up if no meta can be found*/
      /*found a meta, use it*/
      net->tweaked=1;
      net->tweak_lhs=net->metabest; net->tweak_rhs=rhs;
      net->tweak_b4=lhs; net->tweak_posn=posn;
    }
  }
  /*--------------------------------------------*/
  else  /* LHS is a non-base node in itself, search for match... */
  {
    if (net->tweaked==1)
    {
      result_lhs=compare(net,lhs,input,posn);
      if (result_lhs==0) { return(0); }	  
    }
    else 
    {
      result_lhs=tweak_compare(net,lhs,input,posn,rhs);
      if (result_lhs==0)  /*no match, try tweaking entire LHS node... */
      {
        net->wmsize=0; result_lhs=get_meta(net,input,posn,rhs);
        if (result_lhs==0) return(0);
        net->tweaked=1;
        net->tweak_lhs=net->metabest; net->tweak_rhs=rhs;
        net->tweak_b4=lhs; net->tweak_posn=posn;
      }  
    }
  }
  
  /*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/  
  /* now try to match the RHS... 2 sub-scenarios, rhs=base-node or not */
  /* printf("tweak RHS='"); print_node(net,rhs); printf("', with '");
     for (tracer=0; tracer<5; tracer++)
        print_node(net,input->data[result_lhs+tracer]); printf("'\n"); */
  
  if (rhs<=BASE_NODE_SPACE)  /* look at lhs=base-node scenario */
  {
    if (result_lhs>input->size) /*deal with running out of input */
    {
      if (net->tweaked==2) net->tweaked=0;
      result_rhs=off_the_end(net,rhs,input,result_lhs);
      if (result_rhs==0) {return(0); }	
    }
    else if (rhs==input->data[result_lhs])
    {
      result_rhs=result_lhs+1;
    }
    else /*RHS becomes a tweak, so scan forward for PARENT_RHS... */
    {
      if (net->tweaked==1) /* oops, already tweaked, give it up.*/
      {
        net->tweaked=0;
	return(0);
      }

      /* special case when parent_rhs is 0... */
      if (parent_rhs==0)
        { net->tweak_lhs=lhs; net->tweak_posn=result_lhs;
	  net->tweaked=2; net->tweak_b4=rhs; return(result_lhs); }
      
      net->wmsize=0; result_rhs=get_meta(net,input,result_lhs,parent_rhs);
      if (result_rhs==0)
      {
         /* undo any tweaking at this level*/
	 if (net->tweaked==1)
	 {
	   net->tweaked=0;
           return(0); /* give up if no meta can be found*/
	 }
       }
      /*found a meta, use it*/
      net->tweaked=1;
      net->tweak_rhs=net->metabest; net->tweak_lhs=lhs;
      net->tweak_b4=rhs; net->tweak_posn=result_lhs;
      return(result_rhs);
    }
  
  }
  
  /*---------------------------------------------*/
  
  else /* RHS is a non-base node in itself, search for match... */
  {
   
    /* first, a special case when parent_rhs is 0... */
    
    if (net->tweaked==1)
    {
      result_rhs=compare(net,rhs,input,result_lhs);
      if (result_rhs==0) {net->tweaked=0; return(0); }
    } 
    else
    {
      result_rhs=tweak_compare(net,rhs,input,result_lhs,parent_rhs);
				 
      
      if (result_rhs==0) /* ok, try to tweak the entire RHS now.. */
      {
        if (parent_rhs==0)
        { net->tweaked=2; net->tweak_lhs=lhs;  net->tweak_b4=rhs;
	  net->tweak_posn=result_lhs; return(result_lhs); }
	net->wmsize=0; result_rhs=get_meta(net,input,result_lhs,parent_rhs);         
        if (result_rhs==0) return(0);
        net->tweaked=1;
        net->tweak_rhs=net->metabest; net->tweak_lhs=lhs;
        net->tweak_b4=rhs; net->tweak_posn=result_lhs;
      }
    }
  }
  return(result_rhs);
}


/**************************************************************************
 * analyse_tweak_match()
 * 
 * called by find_tweak_match() and find_exact_match()
 * see if a found match is the best so far, and
 * recurse.
 */
 
void analyse_tweak_match(net_type *net,int metanode,
			 nodelist_type *input,int result_posn)
{
  int level=0;
  
  if (net->tweaked!=2)
  /* printf("@@@@ got match '"); print_node(net,metanode); printf("'\n"); */
  level=get_level(net,metanode);
  net->tweaklevel=get_level(net,net->tweak_b4);
  /*printf("level=%i, bestlevel=%i\n",level,net->bestlevel);*/
  if (level>net->bestlevel && net->tweaked!=2)
  {
    if (net->trace>=2)
    {
       printf("@@@@ BEST='"); print_node(net,metanode); printf("', ");
       printf("tweaked=%i\n",net->tweaked);
       if (net->tweaked!=0)
       {
         printf("tweak_lhs='"); print_node(net,net->tweak_lhs);
         printf("', tweak_rhs='"); print_node(net,net->tweak_rhs);
         printf("', tweak_b4='"); print_node(net,net->tweak_b4); printf("'\n");
       }
       printf("best_next=%i\n",result_posn);
       printf("number of LHS outputs=%i\n",net->data[metanode+NUM_LHS_OP]);
       printf("number of RHS outputs=%i\n",net->data[metanode+NUM_RHS_OP]);
    }
    net->best=metanode;
    net->bestlevel=level;
    net->bestnext=result_posn;
    net->besttweaked=net->tweaked;
    net->best_tweak_lhs=net->tweak_lhs;
    net->best_tweak_rhs=net->tweak_rhs;
    net->best_tweaklevel=net->tweaklevel;
    net->best_tweakposn=net->tweak_posn;
    net->best_tweakb4=net->tweak_b4;
    net->best_wmsize=net->wmsize;
    memcpy(net->best_wm,net->wm,(sizeof(int)*ABS_MAX_WMSIZE));
    if (net->mode==2 && net->data[metanode]>=HIGH_BIT) net->mode=3;
  }
  find_tweak_match(net,metanode,input,result_posn);
}


/**************************************************************************
 * find_exact_match( node, input[posn] )
 * This is called from find_tweak_match() - it is the part of it that looks
 * for exact matches.
 */
  
void find_exact_match(net_type *net, int node,nodelist_type *input,int posn)
{
  int metanode,rhs;
  int result_posn;
  int bot,mid,top, safe_mid;
  int explore;
  int outputs,total;
 
  if (net->trace>=4) 
  {
     printf("find_exact_match()\n");
  }
  /* first, a sanity check*/
  outputs=net->data[node+LHS_OP];
  total=net->data[node+NUM_LHS_OP];
 /* printf("find_exact_match - outputs=%i\n",total); */
  if (total==0) return; 
  /* set up pointers to start/end of the list of outputs of our LHS node*/
  bot=outputs;
  top=bot+total-1;
  mid=0; result_posn=FALSE;
  /* printf("bot=%i\n,top=%i\n",bot,top); */
  
  while(bot<=top && result_posn==FALSE)
  {
    mid=bot+(top-bot)/2;
    metanode=net->data[mid];
    if (net->trace>=3) { printf("** looking at metanode '");
    			 print_node(net,metanode); printf("'\n"); }
    rhs=net->data[metanode+RHS_IP];
    net->result=0;
    result_posn=compare(net, rhs, input, posn); /*try to find a match*/
    if (result_posn>0)
    {
      /* printf("FOUND MATCH!!!\n"); */
      analyse_tweak_match(net,metanode,input, result_posn);
      /* pruning? */
      if (net->bestlevel>=(get_level(net,node)+PRUNE)) return;
    }
    else if (net->result<0) bot=mid+1;
    else if (net->result>0) top=mid-1;
  }
  /* If we got a match, then */
  /* explore below and above our match for other potential match candidates*/
  if (result_posn>0)  /* i.e. we got a hit... */
  {
    /* firstly, explore below our hit... */
    safe_mid=mid;
    explore=TRUE;  /* i.e. dont explore if we did'nt find a match */
    if (mid==bot) explore=FALSE;
    while (explore)
    {
      mid--;
      metanode=net->data[mid];
      if (net->trace>=3) { printf("** looking at metanode '");
      			   print_node(net,metanode); printf("'\n"); }
      rhs=net->data[metanode+RHS_IP];    
      result_posn=compare(net, rhs, input, posn); /*try to find a match*/
      if (result_posn!=FALSE)
      {
        /* printf("FOUND MATCH!!!\n"); */
        analyse_tweak_match(net,metanode,input,result_posn);
        /* pruning? */
        if (net->bestlevel>=get_level(net,node)+PRUNE) return;
      }
      else explore=FALSE;
      if (mid==bot) explore=FALSE;
    }
    
    /* now explore above our hit... */
    mid=safe_mid;
    explore=TRUE;
    if (mid==top) explore=FALSE;
    while (explore)
    {
      mid++;
      metanode=net->data[mid];
      if (net->trace>=3) { printf("** looking at metanode '");
      			   print_node(net,metanode); printf("'\n"); }
      rhs=net->data[metanode+RHS_IP];    
      result_posn=compare(net, rhs, input, posn); /*try to find a match*/ 
      if (result_posn!=FALSE)
      {
        /* printf("FOUND MATCH!!!\n"); */
        analyse_tweak_match(net,metanode, input, result_posn);
        /* pruning? */
        if (net->bestlevel>=get_level(net,node)+PRUNE) return;
      }
      else explore=FALSE;
      if (mid==top) explore=FALSE;
    }
  }
  
  /* printf("finished find_exact_match\n"); */
}

/****************************************************************************
 * find_tweak_match()
 * try to find a suitable metanode of 'node' that best matches
 * the current input, from posn onwards, allowing for a single node-tweak.
 * Return value is TRUE OR FALSE. if TRUE, net->best will. be updated
 * Basic assumption- the rhs is ALWAYS a base node in all calls to find_match()
 */

void find_tweak_match(net_type *net, int node, nodelist_type *input, int posn)
{
  int metanode,lhs,rhs;
  int result_posn;
  int finished;
  int tracer;
  int outputs,total, loop;
  int tweaked;
  
  if (net->trace>=4)
  {
    printf("find_tweak_match('"); print_node(net,node); printf("' , '");
    for (tracer=0; tracer<5; tracer++) print_node(net,input->data[posn+tracer]);
    printf("'), tweaks=%i, posn=%i\n",net->tweaked,posn); 
  }
  /* firstly, explore exact matches... */
  if (net->tweaked!=2) find_exact_match(net,node,input,posn);

  finished=FALSE;
  outputs=net->data[node+LHS_OP]; total=net->data[node+NUM_LHS_OP];
  
  /* firstly, there's no point doing a tweak-explore if already tweaked at
     an earlier stage!!! */
  if (net->tweaked==1) finished=TRUE;
  
  /* also, prune if exact matching took us x levels up */
  if (net->bestlevel>=get_level(net,node)+TWEAK_PRUNE) finished=TRUE;
  
  /*  go through every output of our LHS node*/
  loop=0; tweaked=net->tweaked;
  while (loop<total && !finished) /*i.e. still looking at outputs of lhs */
  {
    metanode=net->data[outputs+loop];
    
     if (net->trace>=3) {printf("@@  metanode '"); print_node(net, metanode);
     			 printf("', node '"); print_node(net,node);
			 printf("', data='"); 
      			 for (tracer=0; tracer<5; tracer++)
			     printf("%c",input->data[posn+tracer]/8);
      			  printf("', tweaked=%i\n",net->tweaked);  }
    
    lhs=net->data[metanode+LHS_IP]; rhs=net->data[metanode+RHS_IP];      
    if (net->tweaked==2) /*longshot - skip forward to find the RHS node.*/
    {
      if (net->trace>=3) printf("@@@@ trying the skip forward...\n");
      net->wmsize=0; result_posn=get_meta(net,input, net->tweak_posn, rhs);
      if (net->trace>=3) printf("@@@ result_posn=%i\n",result_posn);
      if (result_posn!=0)
      {
        if (net->trace>=3) printf("SUCCESSFULL TWEAK \n");
	net->tweaked=1;
	net->tweak_rhs=net->metabest;
	/* we need to fix result_posn now, cause it's not at the end of rhs*/
	result_posn=compare(net,rhs,input,result_posn);
	if (result_posn==0) { printf("WOA!!!!!!!\n"); exit(0); }
      }
    }
              /****** plain tweak_match() needed ******/
	   
    else  /* just look for the RHS, possible future tweak if tweaked=0 */
    {         
       result_posn=tweak_compare(net, rhs, input, posn, 0); /*any RHS match?*/
       /* printf("after compare, tweak=%i\n",net->tweaked); */
    }
    /* have a go at tweaking entire node if we can and need to..... */
    if (result_posn==0 && net->tweaked==0)
    {
      /*printf("*** TRY TWEAK WHOLE RHS....\n"); */
      net->tweaked=2; net->tweak_lhs=lhs; net->tweak_b4=rhs;
      net->tweak_posn=posn;
      result_posn=posn;
    }     
         /************ review result *********/
	 
    if (result_posn!=0) /*i.e. we got a match somehow */
      analyse_tweak_match(net,metanode, input, result_posn);
    /* The next line is to prune the search, for speed.... */
    if (net->bestlevel>=(get_level(net,node)+TWEAK_PRUNE)) finished=TRUE;
    net->tweaked=tweaked; loop++;
  }
  /* lastly, explore options where node is the RHS of a metanode... */
  /* chat-mode only! (waaaay too slow and nondeterministic otherwise) */
  if (net->mode!=1 && total==0)
  {
     /* printf("** EXPLORING RHS-OUTPUT OPTIONS NOW\n"); */
      outputs=net->data[node+RHS_OP];
      total=outputs+net->data[node+NUM_RHS_OP];
     for (loop=outputs; loop<total; loop++)
     {
       metanode=net->data[loop];
       /*printf("RHS-EXPLORE OF '"); print_node(net,metanode); printf("'\n");*/
       find_tweak_match(net,metanode,input,posn);
     }
  }
} 

/****************************************************************************
 * multi_tweak_match()
 * wrapper for find_tweak_match() which allows for MULTIPLE tweaks to happen.
 */

void multi_tweak_match(net_type *net, int node, nodelist_type *input, int posn,
		       tweaks_type *tweaks)
{
  int finished;
  int total;

  net->actual=0; finished=FALSE; net->bestnext=posn; net->best=node;
  net->template=node; total=0;
  do
  {
    net->tweaked=0; net->besttweaked=0;
    find_tweak_match(net,net->best,input,net->bestnext);
    if (net->besttweaked==1 &&
        net->best_tweak_lhs!=0 && net->best_tweak_rhs!=0)
    {
       if (net->trace>=3) { printf("SUCCESSFULL TWEAK\n");
         printf("best='"); print_node(net,net->best); printf("', tweak_lhs='");
         print_node(net,net->best_tweak_lhs); printf("', tweak_rhs='");
         print_node(net,net->best_tweak_rhs); printf("', tweak_b4='");
         print_node(net,net->best_tweakb4);
         printf("',best_next=%i, start=%i\n",net->bestnext,net->start); }
       
       /* firstly, build an appropriate node from wm if necessary... */
       if (net->best_wmsize>1)
       {
	  net->wmsize=net->best_wmsize;
	  bcopy(net->best_wm,net->wm,(sizeof(int)*ABS_MAX_WMSIZE));
	  if (net->best_tweak_lhs==net->wm[1])
	     net->best_tweak_lhs=build_from_wm(net);
	  else 
	     net->best_tweak_rhs=build_from_wm(net);
       }
       total++;
       tweaks->lhs[total]=net->best_tweak_lhs;
       tweaks->rhs[total]=net->best_tweak_rhs;
       tweaks->b4[total]=net->best_tweakb4;
       tweaks->posn[total]=net->best_tweakposn;
    }
    else finished=TRUE;
  } while (!finished);
  tweaks->total=total;
  
  /* OK, now that we've got the best node, see if we need to build
     a new node taking all the tweaks into account... */
  if (tweaks->total!=0)
  {
    tweaks->current=1;
    net->best=tweak_build(net,net->best,input,net->start,tweaks);
  }
}

/************************************************************************
 * tweak_build()
 * recursive routine - traverse down node lhs and rhs looking for current
 * tweak in the node, and update the net info so  if referrs to the
 * next level up. Returns the node (new or old) representing the input.
 */
 
int tweak_build(net_type *net, int node, nodelist_type *input, int lhs_posn,
	        tweaks_type *tweaks)
{
  int lhs,rhs,new_lhs,new_rhs, new_node;
  int rhs_posn;  /*pointer to RHS character-level posn */
  
  /* printf("**** inside tweak_build()  ");
     printf("node='"); print_node(net,node);
     printf("', t_lhs='"); print_node(net,tweaks->lhs[tweaks->current]);
     printf("',t_rhs='"); print_node(net,tweaks->rhs[tweaks->current]);
     printf("', tweak_pson=%i, lhs_posn=%i\n",tweaks->posn[tweaks->current],
            lhs_posn);   */
  
  /* firstly, sanity check ... */
  if (node<=BASE_NODE_SPACE) {printf("tweak_build WTF?\n"); exit(0);} /*oops!*/
  
  /* OK, look at each child of node */
  lhs=net->data[node+LHS_IP];  rhs=net->data[node+RHS_IP];
  new_lhs=lhs; new_rhs=rhs; new_node=node; /*in case no tweaking done here.. */
   
  /*---------------------------------------------------*/
  /* firstly, LHS.... */
  if (tweaks->b4[tweaks->current]==lhs &&
      tweaks->posn[tweaks->current]==lhs_posn)
  {
     new_lhs=tweaks->lhs[tweaks->current]; tweaks->current++;
  }
  else if (lhs>BASE_NODE_SPACE)
                          new_lhs=tweak_build(net,lhs,input,lhs_posn,tweaks);
  else rhs_posn=lhs_posn+1;
  
  /*--------------------------------------------------*/
  /* now the RHS..... */

  rhs_posn=lhs_posn+get_node_size(net,new_lhs);
  
  if (tweaks->b4[tweaks->current]==rhs &&
      tweaks->posn[tweaks->current]==rhs_posn)
  {
    new_rhs=tweaks->rhs[tweaks->current]; tweaks->current++;
  }
  else if (rhs>BASE_NODE_SPACE)
                         new_rhs=tweak_build(net,rhs,input,rhs_posn,tweaks);
  
  /* --------------------------------------------------*/
  /* lastly, we need to return either the original node or a new one*/
  if (new_lhs!=lhs)      new_node=make_node(net,new_lhs,new_rhs);
  else if (new_rhs!=rhs) new_node=make_node(net,new_lhs,new_rhs);
  
  return(new_node);
}
